
BEGIN (* Do_Xmodem_Download *)
                                   (* Reset comm parms to 8,n,1 *)

   Xmodem_Bits_Save   := Data_Bits;
   Xmodem_Parity_Save := Parity;

   IF ( Data_Bits <>  8  ) OR
      ( Parity    <> 'N' ) THEN
         BEGIN
            Parity    := 'N';
            Data_Bits := 8;
            Async_Reset_Port( Comm_Port, Baud_Rate, 'N', 8, 1 );
         END;

                                   (* Reset status line *)
   IF Do_Status_Line THEN
      BEGIN
         Set_Status_Line_Name( Short_Terminal_Name );
         Write_To_Status_Line( Status_Line_Name, 1 );
      END;

                                   (* Perform transfer          *)
   CASE Transfer_Protocol Of

      Xmodem_Chk:     Receive_Xmodem_File( FALSE );

      Modem7_CRC,
      Telink:         Receive_Modem7_File( TRUE );

      Modem7_Chk:     Receive_Modem7_File( FALSE );

      SeaLink,
      Ymodem_G,
      Ymodem_Batch:   Receive_Ymodem_File;

      Xmodem_1K,
      Xmodem_1KG,
      WXmodem,
      Xmodem_Crc:     Receive_Xmodem_File( TRUE );

      ELSE ;

   END  (* CASE *);
                                   (* Reset comm parms back *)

   IF ( Xmodem_Bits_Save   <>  8  ) OR
      ( Xmodem_Parity_Save <> 'N' ) THEN
         BEGIN
            Parity    := Xmodem_Parity_Save;
            Data_Bits := Xmodem_Bits_Save;
            Async_Reset_Port( Comm_Port, Baud_Rate, Parity,
                              Data_Bits, Stop_Bits );
         END;

                                   (* Reset status line *)
   IF Do_Status_Line THEN
      BEGIN
         Set_Status_Line_Name( Short_Terminal_Name );
         Write_To_Status_Line( Status_Line_Name, 1 );
      END;

END   (* Do_Xmodem_DownLoad *);
