BEGIN (* Do_Xmodem_Upload *)
                                   (* Set comm. parms to 8,n,1 *)

   Xmodem_Bits_Save   := Data_Bits;
   Xmodem_Parity_Save := Parity;

   IF ( Data_Bits <>  8  ) OR
      ( Parity    <> 'N' ) THEN
         BEGIN
            Parity    := 'N';
            Data_Bits := 8;
            Async_Reset_Port( Comm_Port, Baud_Rate, Parity, Data_Bits, Stop_Bits );
         END;

                                   (* Reset status line *)
   IF Do_Status_Line THEN
      BEGIN
         Set_Status_Line_Name( Short_Terminal_Name );
         Write_To_Status_Line( Status_Line_Name, 1 );
      END;

                                   (* Perform transfer *)
   CASE Transfer_Protocol OF

      Xmodem_Chk   : Send_Xmodem_File( FALSE );

      WXmodem,
      Xmodem_CRC   : Send_Xmodem_File( TRUE  );

      Telink,
      Modem7_CRC   : Send_Modem7_File( TRUE  );

      Modem7_Chk   : Send_Modem7_File( FALSE );

      SeaLink,
      Ymodem_G,
      Ymodem_Batch : Send_Ymodem_File( TRUE  );

      Xmodem_1K,
      Xmodem_1KG   : Send_Ymodem_File( FALSE );

      ELSE ;

   END  (* Case *);
                                   (* Reset comm parms to saved values *)

   IF ( Xmodem_Bits_Save   <>  8  ) OR
      ( Xmodem_Parity_Save <> 'N' ) THEN
         BEGIN
            Parity    := Xmodem_Parity_Save;
            Data_Bits := Xmodem_Bits_Save;
            Async_Reset_Port( Comm_Port, Baud_Rate, Parity,
                              Data_Bits, Stop_Bits );
         END;

                                   (* Reset status line *)
   IF Do_Status_Line THEN
      BEGIN
         Set_Status_Line_Name( Short_Terminal_Name );
         Write_To_Status_Line( Status_Line_Name, 1 );
      END;

END   (* Do_Xmodem_Upload *);
